const MODIFY_HIDDEN_LAYERS = true;
const MODIFY_LOCKED_LAYERS = true;

const MODIFY_HIDDEN_ITEMS = true;
const MODIFY_LOCKED_ITEMS = true;

const HAIRLINE_CHECK_WIDTH = 0.25;
const HAIRLINE_SET_WIDTH = 0.5;

function SetStrokeWidth(pathItem) {
	
	if(pathItem.hidden) {
		
		if(MODIFY_HIDDEN_ITEMS) {
							
			pathItem.hidden = false;								
			pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
			pathItem.hidden = true;
			return 1;
		}
		else return 0;
	}
	else {

		if(pathItem.locked) {
			
			if(MODIFY_LOCKED_ITEMS) {
								
				pathItem.locked = false;								
				pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
				pathItem.locked = true;
				return 1;
			}
			else return 0;
		}
		else {
			
			pathItem.strokeWidth = HAIRLINE_SET_WIDTH;
			return 1;
		}
	}
}

function main() {

	if(app.documents.length) {
		
		var lockedLayers = new Array();
		var visibleLayers = new Array();		
		
		var hairLineCounter = 0;
		var changeCounter = 0;
		var pathItem;

		for(var i = 0; i < app.activeDocument.pathItems.length; i++) {
			
			if(!app.activeDocument.pathItems[i].guides) {
				
				pathItem = app.activeDocument.pathItems[i];

				try {

					if((pathItem.strokeWidth > 0)&&(pathItem.strokeWidth < HAIRLINE_CHECK_WIDTH)) {
						
						hairLineCounter++;
						if(pathItem.hidden) {
															
							if(MODIFY_HIDDEN_ITEMS) {
							
								pathItem.hidden = false;								
								pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
								pathItem.hidden = true;
								changeCounter++;
							}
							else ;
						}
						else {

							if(pathItem.locked) {
								
								if(MODIFY_LOCKED_ITEMS) {
								
									pathItem.locked = false;								
									pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
									pathItem.locked = true;
									changeCounter++;
								}
								else ;
							}
							else {
								
								pathItem.strokeWidth = HAIRLINE_SET_WIDTH;
								changeCounter++;
							}
						}
					}
					else ;
				}
			
				catch(anyError) {
			
					if(pathItem.layer.locked) {
						
						if(MODIFY_LOCKED_LAYERS) {
				
							if(!pathItem.layer.visible) {
								
								if(MODIFY_HIDDEN_LAYERS) {
						
									pathItem.layer.locked = false;
									pathItem.layer.visible = true;
									lockedLayers.push(pathItem.layer);
									visibleLayers.push(pathItem.layer);							
									changeCounter += SetStrokeWidth(pathItem);
								}
								else ;
							}
							else {
						
								pathItem.layer.locked = false;
								lockedLayers.push(pathItem.layer);							
								changeCounter += SetStrokeWidth(pathItem);
							}
						}
						else ;
					}
					else {
				
						if(!pathItem.layer.visible) {
						
							if(MODIFY_HIDDEN_LAYERS) {
							
								pathItem.layer.visible = true;
								visibleLayers.push(pathItem.layer);
								changeCounter += SetStrokeWidth(pathItem);
							}
							else ;
						}
						else {
					
							alert("Cannot Set HairLine StrokeWidth. Unknown error...");
							exit();
						}
					}
				}
			}
			else ;
		}
		
		for(i = 0; i < visibleLayers.length; i++) visibleLayers[i].visible = false;
		for(i = 0; i < lockedLayers.length; i++) lockedLayers[i].locked = true;
		alert("HairLine PathItems Number = " + hairLineCounter + "\n" + "Modified PathItems Number = " + changeCounter);			
	}
	else alert("Open document and try again...");
}		

main();